<?php
// выход или перезагрузка
function quit()
{
   global $app;

   // чистим всё
   $app->clear();
   // выходим
   $app->quit();
}
// key - ключ сервиса
// $country=0 - по умолчанию Россия
// $wt=10 - время ожидание номера в секундах 
function get_phone($key, $country=0, $wt=10,$servis='http://sms-activate.ru')
{
    global $smsactivate;

	// задаём ключ апи сервиса
	$smsactivate->api_key = $key;
	$smsactivate->servis = $servis;

	// получить номер телефона
	if(!$smsactivate->get_phone_number('go','any',$country))
	{
        // ожидаем номер
		while($smsactivate->answer=="NO_NUMBERS")
		{
			$smsactivate->get_phone_number('go','any',$country);
			sleep($wt);
		}
	 
		if(strpos($smsactivate->answer,'ACCESS_NUMBER')===false)
		{
		   echo("ответ $smsactivate->servis серваса $smsactivate->answer<br>");
		   quit();
		}
	}
	 
	// смс отправлен
	$smsactivate->set_status(1);
	// полученный номер телефона
	return $phone= trim($smsactivate->number);
}

// $wt_wait=10 - ожидание между ответом
function wait_code($wt_wait=10)
{
    global $smsactivate;
	// получить код из смс
	if(!$smsactivate->get_code($wt_wait))
	{
		echo("ОШИБКА: $smsactivate->answer не смогли получить код из СМС-сообщения");
	 
		// сообщаем сервису что освобождаем номер
		$smsactivate->set_status(8); 
	}
	else // при необходимости поправить разбор текста смс, если код будет не верно разбираться из него
	{
		// сообщаем сервису что всё ok
		$smsactivate->set_status(); 
		// код из смс

	    return $smsactivate->code;
	}
   
    return '';
}

// Генерируем пароль
function generate_password($number)
  {
    $arr = array('a','b','c','d','e','f',
                 'g','h','i','j','k','l',
                 'm','n','o','p','r','s',
                 't','u','v','x','y','z',
                 'A','B','C','D','E','F',
                 'G','H','I','J','K','L',
                 'M','N','O','P','R','S',
                 'T','U','V','X','Y','Z',
                 '1','2','3','4','5','6',
                 '7','8','9','0','.',',',
                 '(',')','[',']','!','?',
                 '&','^','%','@','*','$',
                 '<','>','/','|','+','-',
                 '{','}','`','~');
    // Генерируем пароль
    $pass = "";
    for($i = 0; $i < $number; $i++)
    {
      // Вычисляем случайный индекс массива
      $index = rand(0, count($arr) - 1);
      $pass .= $arr[$index];
    }
    return $pass;
  }

// Функция русского текста в английскую транслитерацию
function rus2translit($text)
{
	// Русский алфавит
	$rus_alphabet = array(
		'А', 'Б', 'В', 'Г', 'Д', 'Е', 'Ё', 'Ж', 'З', 'И', 'Й',
		'К', 'Л', 'М', 'Н', 'О', 'П', 'Р', 'С', 'Т', 'У', 'Ф',
		'Х', 'Ц', 'Ч', 'Ш', 'Щ', 'Ъ', 'Ы', 'Ь', 'Э', 'Ю', 'Я',
		'а', 'б', 'в', 'г', 'д', 'е', 'ё', 'ж', 'з', 'и', 'й',
		'к', 'л', 'м', 'н', 'о', 'п', 'р', 'с', 'т', 'у', 'ф',
		'х', 'ц', 'ч', 'ш', 'щ', 'ъ', 'ы', 'ь', 'э', 'ю', 'я'
	);
	
	// Английская транслитерация
	$rus_alphabet_translit = array(
		'A', 'B', 'V', 'G', 'D', 'E', 'IO', 'ZH', 'Z', 'I', 'I',
		'K', 'L', 'M', 'N', 'O', 'P', 'R', 'S', 'T', 'U', 'F',
		'H', 'C', 'CH', 'SH', 'SH', '`', 'Y', '`', 'E', 'IU', 'IA',
		'a', 'b', 'v', 'g', 'd', 'e', 'io', 'zh', 'z', 'i', 'i',
		'k', 'l', 'm', 'n', 'o', 'p', 'r', 's', 't', 'u', 'f',
		'h', 'c', 'ch', 'sh', 'sh', 'y', 'e', 'iu', 'ia'
	);

	return str_replace($rus_alphabet, $rus_alphabet_translit, $text);
}

// ========================================================
// выдать сообщение в панель отладки и в debug file
function debug_mess($mess)
{
   global $dbg, $textfile, $debug_file;
   // отладочные сообщения
   if ($dbg)
   {
      echo date("\[ d.m.y H:i:s\] ") . $mess . "<br>";
   }
	if (isset($debug_file))
	{
		// создаем сообщение для записи в файл отладки
		$str = date("\[ d.m.y H:i:s\] ") . $mess."\r\n";
		// записываем сообщение
      $textfile->add_string_to_file($debug_file, $str);
	}
}

// ждём на подгрузку нужного нам элемента
function wait_on_element_by_text($tag, $text, $frme=-1, $wait=10, $pause=1)
{
  $a=0;

  while(!$tag->is_exist_by_inner_text($text, false, $frme))
  {   
     sleep($pause);
     if($a>$wait)
     {
        debug_mess("ОШИБКА: не дождались нужного элемента c текстом $text!");
       return false;   
     }

     $a++;
  }
   
  return true;   
}
// ждём на подгрузку нужного нам элемента по атрибуту
function wait_on_element_by_att($tag, $att_name, $att_text, $frme=-1, $wait=10, $pause=1)
{
  $a=0;

  while(!$tag->is_exist_by_attribute($att_name, $att_text, false, $frme))
  {   
     sleep($pause);
     if($a>$wait)
     {
        debug_mess("ОШИБКА: не дождались нужного элемента c текстом $text!");
       return false;   
     }

     $a++;
  }
   
  return true;   
}

// ждём на подгрузку нужного нам элемента
function wait_exists_element_by_text($tag, $text, $frme=-1, $wait=30, $pause=1)
{
  $a=0;

  while($tag->is_exist_by_inner_text($text, true, $frme))
  {   
     sleep($pause);
     if($a>$wait)
     {
       debug_mess("ОШИБКА: элемент с тектом $text всё ещё на странице! Ожидали $a секунд.");
       return false;   
     }

     $a++;
  }
   
  return true;   
}

// Удаление повторяющихся слов
function delete_duplicates_words($text)
{
    $text = implode(array_reverse(preg_split('//u', $text)));
    $text = preg_replace('/(\b[\pL0-9]++\b)(?=.*?\1)/siu', '', $text);
    $text = implode(array_reverse(preg_split('//u', $text)));
    return $text;
}

// получить номер фрейма по тексту в нём
function get_frame_number_by_text($tag, $text)
{
    for($i=0;$i<15;$i++)
    if($tag->is_exist_by_inner_text($text, false, $i))
      return $i;

 return -1;
}
// чистим всю информацию по браузеру
function сlear_browser_info()
{
   global $browser;
   $browser->close_all_tabs();
    // navigate to google  
   $browser->navigate("about:blank");
   sleep(1);
   $browser->clear_cookies("");
   sleep(1);
   $browser->clear_cache();
   sleep(1); 

   return true;
}

// получить строку по префиксам
function get_string($str1, $pr1, $pr2, &$ind_st = 0)
{
	//получаем стартовый индекс
	$ind1 = strpos($str1, $pr1, $ind_st);
	if($ind1 === false)
	{
		return "";
	}
	$ind1_1 = $ind1 + strlen($pr1);
	//получаем финишный индекс
	$ind2 = strpos($str1, $pr2, $ind1_1);
	if ($ind2 === false)
	{
		return "";
	}
	// получим результат
	$sres = substr($str1, $ind1 + strlen($pr1), $ind2 - $ind1_1);
	return trim($sres); 
}

// проверим встречается ли подстрока в строке
function is_exists_str($str,$substr)
{
	$result = strpos($str, $substr);

	if ($result === FALSE) 
		return false;
	else
		return true;   
}

?>